using System;
using System.Collections.Generic;
using UnityEngine;

namespace Syntriax.Modules.Trigger
{
    public interface IColliderTriggerArea : ITriggerArea
    {
        /// <summary>
        /// <see cref="LayerMask"/> value for checking triggers
        /// </summary>
        LayerMask ColliderMask { get; set; }

        /// <summary>
        /// Called whenever the list of <see cref="Collider2D"/> changes
        /// </summary>
        /// <value>List of <see cref="Collider2D"/> that triggered the <see cref="IColliderTriggerArea"/></value>
        Action<List<Collider2D>> OnTriggeredCollidersUpdated { get; set; }

        /// <value>List of <see cref="Collider2D"/> that triggered the <see cref="IColliderTriggerArea"/></value>
        List<Collider2D> ColliderList { get; }
    }
}
