using System;
using Syntriax.Modules.ToggleState;

namespace Syntriax.Modules.Trigger
{
    public interface ITrigger
    {
        /// <summary>
        /// Member <see cref="IToggleState"/> to switch on or off
        /// </summary>
        IToggleState ToggleStateMember { get; }

        /// <summary>
        /// Called everytime the IsTrigerred field is changed
        /// </summary>
        /// <value>The new value of IsTrigerred</value>
        Action<bool> OnTriggerStateChanged { get; set; }

        bool IsTrigerred { get; }
    }
}
